use32
	org 0x0
	db 'MENUET01'
	dd 0x1
	dd start
	dd i_end
	dd mem,stacktop
	dd 0,cur_dir_path

include 'D:/Kolibri/svn/programs/proc32.inc'
include 'D:/Kolibri/svn/programs/macros.inc'
include 'info_fun_float.inc'

align 4
start:
	mcall 40,0x27

	stdcall func_mv, matr1,vect1

align 4
red_win:
	call draw_window

align 4
still:
	mcall 10
	cmp al,1
	jz red_win
	cmp al,2
	jz key
	cmp al,3
	jz button
	jmp still

align 4
draw_window:
	pushad
	mcall 12,1

	;mov edx,0x32000000
	mov edx,0x33ffffff
	mcall 0,(50 shl 16)+330,(30 shl 16)+275,,,caption

;...

	mcall 12,2
	popad
	ret

align 4
key:
	mcall 2

	cmp ah,27 ;Esc
	je button.exit

	jmp still

align 4
button:
	mcall 17
	cmp ah,1
	jne still
.exit:

	mcall -1

align 4
proc func_mv, m:dword, v:dword
pushad
	mov ebx,[m]
	mov edx,[v]
	mov ecx,4
	.cycle_0:
		finit
		fld dword[edx]
		fld dword[edx+4]
		fld dword[edx+8]
;fwait
		fld dword[ebx]	   ;st0 = m[0]
		fmul st0,st3	   ;st0 *= v.coord.X
		fld dword[ebx+4]   ;st0 = m[1]
		fmul st0,st3	   ;st0 *= v.coord.Y
		fld dword[ebx+8]   ;st0 = m[2]
		fmul st0,st3	   ;st0 *= v.coord.Z
		fadd dword[ebx+12] ;st0 += m[3]
		fadd st0,st1	   ;st0 += v.coord.Z * m[2]
		fadd st0,st2	   ;st0 += v.coord.Y * m[1]
		fstp dword[edx]    ;v.coord.X = v.coord.X * m[0] + v.coord.Y * m[1] + v.coord.Z * m[2] + m[3]
;               fincstp
;               fincstp
;fwait
		add ebx,16 ;следущая строка матрицы
		add esi,4  ;следущая координата вектора
;fwait
		loop .cycle_0
	stdcall print_matrix,[v],1
popad
	ret
endp

align 4
proc print_matrix uses eax ebx ecx edi, m:dword, rows:dword
	mov ecx,[rows]
	cmp ecx,1
	jl .end_f
	mov ebx,[m]
	mov word[NumberSymbolsAD],3
	finit
	@@:
		lea edi,[buf_param]
		mov byte[edi],0

		fld dword[ebx]
		fstp qword[Data_Double]
		call DoubleFloat_to_String
		stdcall str_cat, edi,Data_String

		stdcall str_n_cat,edi,txt_zp_sp,2
		stdcall str_len,edi
		add edi,eax

		fld dword[ebx+4]
		fstp qword[Data_Double]
		call DoubleFloat_to_String
		stdcall str_cat, edi,Data_String

		stdcall str_n_cat,edi,txt_zp_sp,2
		stdcall str_len,edi
		add edi,eax

		fld dword[ebx+8]
		fstp qword[Data_Double]
		call DoubleFloat_to_String
		stdcall str_cat, edi,Data_String

		stdcall str_n_cat,edi,txt_zp_sp,2
		stdcall str_len,edi
		add edi,eax

		fld dword[ebx+12]
		fstp qword[Data_Double]
		call DoubleFloat_to_String
		stdcall str_cat, edi,Data_String

		stdcall str_n_cat,edi,txt_nl,2
		stdcall dbg_print,txt_sp,buf_param
		
		add ebx,16
	dec ecx
	cmp ecx,0
	jg @b
	.end_f:
	ret
endp

align 4
proc dbg_print, fun:dword, mes:dword
pushad
	mov eax,63
	mov ebx,1

	mov esi,[fun]
	@@:
		mov cl,byte[esi]
		int 0x40
		inc esi
		cmp byte[esi],0
		jne @b
	mov cl,':'
	int 0x40
	mov cl,' '
	int 0x40
	mov esi,[mes]
	@@:
		mov cl,byte[esi]
		int 0x40
		inc esi
		cmp byte[esi],0
		jne @b
popad
	ret
endp

align 4
proc str_n_cat uses eax ecx edi esi, str1:dword, str2:dword, n:dword
	mov esi,dword[str2]
	mov ecx,dword[n]
	mov edi,dword[str1]
	stdcall str_len,edi
	add edi,eax
	cld
	repne movsb
	mov byte[edi],0
	ret
endp

align 4
txt_nl db 13,10,0
txt_sp db ' ',0
txt_zp_sp db ', ',0

align 4
buf_param rb 80
caption db 'Test matrix, [Esc] - exit',0

align 4
matr1 dd 1.0,0.0,0.0,0.0
	dd 0.0,1.0,0.0,0.0
	dd 0.0,0.0,1.0,0.0
	dd 0.0,0.0,0.0,1.0

vect1 dd 0.5,0.7,0.9,1.1

i_end:
	rb 1024
stacktop:
cur_dir_path:
	rb 4096
library_path:
	rb 4096
mem: